image: node:latest

stages:
  - pre-build
  - build
  - test
  - publish

.only-default: &only-default
  only:
    - master
    - merge_requests
    - tags

lint:
  stage: pre-build
  <<: *only-default
  script:
    - yarn lint

validate yarn cache:
  stage: pre-build
  only: 
    - merge-requests
  script:
    - yarn install --check-cache

build:
  stage: build
  <<: *only-default
  script:
    - yarn build
  artifacts:
    untracked: true

test:
  stage: test
  <<: *only-default
  script:
    - yarn test

publish:
  stage: publish
  only: 
    - tags
  dependencies:
    - build
  script:
    - yarn npm publish
